searchNodes=[{"ref":"Ark.html","title":"Ark","type":"module","doc":"Ark is a collection of small utilities useful for prototyping, testing, and working with Elixir common patterns. Utilities Ark.Ok This module provides function to work with ok/error tuples. Ark.PipeIn This module provides a macro to set a variable from the end of a pipe. use Ark.PipeIn :val |&gt; Atom.to_string() |&gt; String.upcase() ~&gt; my_value IO.inspect(my_value, label: &quot;my_value&quot;) # my_value: &quot;VAL&quot; Ark.Drip This module implements a GenServer and allows to throttle calls to a common resource."},{"ref":"Ark.Drip.html","title":"Ark.Drip","type":"module","doc":""},{"ref":"Ark.Drip.html#await/2","title":"Ark.Drip.await/2","type":"function","doc":""},{"ref":"Ark.Drip.html#cancel/2","title":"Ark.Drip.cancel/2","type":"function","doc":""},{"ref":"Ark.Drip.html#child_spec/1","title":"Ark.Drip.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Ark.Drip.html#init/1","title":"Ark.Drip.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Ark.Drip.html#start/2","title":"Ark.Drip.start/2","type":"function","doc":""},{"ref":"Ark.Drip.html#start_link/1","title":"Ark.Drip.start_link/1","type":"function","doc":""},{"ref":"Ark.Drip.html#start_link/2","title":"Ark.Drip.start_link/2","type":"function","doc":""},{"ref":"Ark.Drip.html#stop/1","title":"Ark.Drip.stop/1","type":"function","doc":""},{"ref":"Ark.Ok.html","title":"Ark.Ok","type":"module","doc":""},{"ref":"Ark.Ok.html#ok/1","title":"Ark.Ok.ok/1","type":"function","doc":"Wrapping ok. Converts a value to an :ok tuple, except when the value is: the single atom :ok or an :ok tuple the single atom :error or an :error tuple"},{"ref":"Ark.Ok.html#ok?/1","title":"Ark.Ok.ok?/1","type":"function","doc":"Questionning ok. Returns true if the value is an {:ok, val} tuple or the single atom :ok. Returns false otherwise."},{"ref":"Ark.Ok.html#uok/1","title":"Ark.Ok.uok/1","type":"function","doc":"Unwrapping ok. Unwraps an {:ok, val} tuple, giving only the value, returning anything else as-is. Does not unwrap {:error, ...} tuples. This function should not be used as it leads to ambiguous code where errors are still wrapped in tuples but values are &quot;naked&quot;. A case pattern matching on that type would be very unusual in Elixir/Erlang. Match on the original value or use uok!/1."},{"ref":"Ark.Ok.html#uok!/1","title":"Ark.Ok.uok!/1","type":"function","doc":"Unwrapping ok with raise. Unwraps an {:ok, val} tuple, giving only the value, or returns the single :ok atom as-is. Raises with any other value."},{"ref":"Ark.Ok.html#wok/1","title":"Ark.Ok.wok/1","type":"function","doc":"wok is an alias of wrapping function :ok."},{"ref":"Ark.Ok.UnwrapError.html","title":"Ark.Ok.UnwrapError","type":"exception","doc":""},{"ref":"Ark.PipeIn.html","title":"Ark.PipeIn","type":"module","doc":""},{"ref":"Ark.PipeIn.html#~>/2","title":"Ark.PipeIn.~>/2","type":"macro","doc":""},{"ref":"Ark.PubSub.html","title":"Ark.PubSub","type":"module","doc":""},{"ref":"Ark.PubSub.html#child_spec/1","title":"Ark.PubSub.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Ark.PubSub.html#clear/2","title":"Ark.PubSub.clear/2","type":"function","doc":""},{"ref":"Ark.PubSub.html#publish/3","title":"Ark.PubSub.publish/3","type":"function","doc":""},{"ref":"Ark.PubSub.html#start/1","title":"Ark.PubSub.start/1","type":"function","doc":""},{"ref":"Ark.PubSub.html#start_link/1","title":"Ark.PubSub.start_link/1","type":"function","doc":""},{"ref":"Ark.PubSub.html#subscribe/3","title":"Ark.PubSub.subscribe/3","type":"function","doc":""},{"ref":"Ark.PubSub.html#subscribe/4","title":"Ark.PubSub.subscribe/4","type":"function","doc":""},{"ref":"Ark.PubSub.html#unsubscribe/3","title":"Ark.PubSub.unsubscribe/3","type":"function","doc":""},{"ref":"Ark.PubSub.Group.html","title":"Ark.PubSub.Group","type":"module","doc":""},{"ref":"Ark.PubSub.Group.html#publish/2","title":"Ark.PubSub.Group.publish/2","type":"function","doc":""},{"ref":"Ark.PubSub.Group.html#subscribe/2","title":"Ark.PubSub.Group.subscribe/2","type":"function","doc":""}]